;a modest example - video view w/ controls
;has been tested with:
; Pioneer 8000 lasedisc player
; RasterOps 364 video digitizer
; MoonRaker video digitizer

(oou-dependencies :video-wm
                  :video-svm
                  
                  :P8000-vp
                  
                  :MR-vd
                  :RO364-vd)


(defclass vview (video-svm simple-view) ())

(progn
  (defparameter *test-w* nil)
  (setf *test-w*
    (make-instance
     'video-dialog
     :window-type :document
     :view-size #@(320 340)
     :window-title "video demo"
     :color-p t
     :view-subviews
     (list
       (make-instance 'vview
;                      :digitizer-class 'RO364-vd
                       :digitizer-class 'MR-vd
                       :player-class    'P8000-vp
                       :port :printer
                       :view-position   #@(10 10)
                       :view-size       #@(300 250)                  
                       :view-nick-name  :vview
                       :framehook-fn #'(lambda (frame)
                                         (set-dialog-item-text (view-named :cur-frame *test-w*) (princ-to-string frame)))
                       )
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text "<<<"
                       :dialog-item-action #'(lambda (di) (vp-jump (view-named :vview (view-container di)) :reverse 500)))
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text "<<"
                       :dialog-item-action #'(lambda (di) (vp-scan (view-named :vview (view-container di)) :reverse 4)))
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text "|<"
                       :dialog-item-action #'(lambda (di) (vp-step (view-named :vview (view-container di)) :reverse)))
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text ""
                       :dialog-item-action #'(lambda (di) (vp-stop (view-named :vview (view-container di)))))
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text ">|"
                       :dialog-item-action #'(lambda (di) (vp-step (view-named :vview (view-container di)) :forward)))
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text ">"
                       :dialog-item-action #'(lambda (di) (vp-play (view-named :vview (view-container di)))))
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text ">>"
                       :dialog-item-action #'(lambda (di) (vp-scan (view-named :vview (view-container di)) :forward 4)))
       (make-instance 'button-dialog-item
                       :view-size #@(30 20)
                       :dialog-item-text ">>>"
                       :dialog-item-action #'(lambda (di) (vp-jump (view-named :vview (view-container di)) :forward 500)))
       (make-instance 'static-text-dialog-item
                       :dialog-item-text "current frame number:")
       (make-instance 'static-text-dialog-item
                       :view-nick-name :cur-frame
                       :view-size #@(100 20)
                       :dialog-item-text "????????")
       )))
  (vp-load (view-named :vview *test-w*))
  )

#|

(vp-play-clip (view-named :vview *test-w*) 10 50)

|#